#include <unicorn/unicorn.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>



#define ADDRESS 0x1000 

static void hook_block(uc_engine *uc, uint64_t address, uint32_t size,
                       void *user_data)
{
	printf("addr: 0x%x\n",address);
	//if (uc->set_pc) {
			   // }
			   // 0xfc02d240 virt 0x39240
			   //
#if 0
	int pc;
	uint32_t  buffer[256];
    printf(">>> Tracing basic block at 0x%" PRIx64 ", block size = 0x%x\n",
           address, size);
	uc_mem_read(uc,address,buffer,sizeof(uint32_t));
	printf("inst %s\n",(unsigned char*)buffer);
	if (address ==0xfc02d240)
	{
		printf("here\n");
		uint32_t memint=0;
		pc = 0xfc02d240;
		uc_mem_read(uc,pc,&memint,1);
		printf("memint 0x%x\n",memint);
    		//uc_reg_write(uc, UC_ARM_REG_PC, &pc);
	}

    	uc_reg_read(uc, UC_ARM_REG_PC, &pc);
	printf("PC: 0x%x\n",pc);
#endif
}



static void test_arm(void)
{
    uc_engine *uc;
    uc_err err;
    uc_hook trace1, trace2;

    struct stat loadlen;
    int r0 = 0x1234; // R0 register
    int r2 = 0x6789; // R1 register
    int r3 = 0x3333; // R2 register
    int sp = 1024*1024*16; // R2 register
    int r1,r8,pc;          // R1 register
    int lr;
    int armfd=0;
    int armsize;
    unsigned char * testcode;
    char b;
    printf("Emulate ARM code\n");
    armfd = open ("mmuhack,ffd",O_RDONLY);
    fstat(armfd, &loadlen);
    armsize = loadlen.st_size;
    testcode = (unsigned char*) malloc(armsize+100);
    read(armfd,testcode,armsize);
    perror("read");
    close (armfd);
    // Initialize emulator in ARM mode
    err = uc_open(UC_ARCH_ARM, UC_MODE_ARM, &uc);
    if (err) {
        printf("Failed on uc_open() with error returned: %u (%s)\n", err,
               uc_strerror(err));
        return;
    }
    err=uc_mem_map(uc, ADDRESS, 128 *  1024 * 1024, UC_PROT_ALL);
    if (err) {
        printf("Failed on uc_emu_map() with error returned: %s\n", uc_strerror(err));
    }
    uc_hook_add(uc, &trace1, UC_HOOK_BLOCK, hook_block, NULL, 1, 0);
   printf("before start %d\n",armsize);
    uc_mem_write(uc, ADDRESS,testcode, armsize);
   printf("before start %d\n",armsize);
   uc_reg_write(uc, UC_ARM_REG_SP, &sp);
    err = uc_emu_start(uc, ADDRESS, 0, 0, 0);
    if (err) {
        printf("Failed on uc_emu_start() with error returned: %s\n", uc_strerror(err));
    }

    // now print out some registers
    printf(">>> Emulation done. Below is the CPU context\n");
    uc_reg_read(uc, UC_ARM_REG_R0, &r0);
    uc_reg_read(uc, UC_ARM_REG_R1, &r1);
    uc_reg_read(uc, UC_ARM_REG_R8, &r8);
    uc_reg_read(uc, UC_ARM_REG_PC, &pc);
    uc_reg_read(uc, UC_ARM_REG_LR, &lr);
    printf(">>> R0 = 0x%x\n", r0);
    printf(">>> R1 = 0x%x\n", r1);
    printf(">>> R8 = 0x%x\n", r8);
    printf(">>> PC = 0x%x\n", pc);
    printf(">>> LR = 0x%x\n", lr);

    uc_close(uc);
}


int main(int argc, char **argv)//, char **envp)
{
	test_arm();
	return (0);
}
